import greenfoot.*;

/**
 * 
 */
public class FlappyWorld extends World
{
    int pipeCounter=0;
    int flappyCounter=0;
    int PIPE_SPACING=160;
    int score=0;
    int FIRST_PIPE=240;
    Score scoreObj=null;

    /**
     * Constructor for objects of class MyWorld.
     */
    public FlappyWorld()
    {
        super(600, 400, 1,false);
        //set paint order

        setPaintOrder(GameOver.class,Score.class,FlappyBird.class,Pipe.class);
        //Create a Flappy Bird Object

        FlappyBird flappy=new FlappyBird();
        //add flappy to our world

        addObject(flappy,100,getHeight()/2);
        //Create a Score object

        scoreObj=new Score();
        scoreObj.setScore(0);
        //Add it to our world
        addObject(scoreObj,70,355);
        prepare();
    }

    public void act()
    {
        pipeCounter++;
        //System.out.println(counter);
        if(pipeCounter%100==0)
        {//Create a pipe object
            createPipes();
        }

        if(pipeCounter>=FIRST_PIPE)
        {
            if(flappyCounter%100==0)
            {
                score++;
                scoreObj.setScore(score);
            }
            flappyCounter++;
        }
    }

    private void createPipes()
    {
        Pipe topPipe=new Pipe();
        Pipe botPipe=new Pipe();

        GreenfootImage image=botPipe.getImage();

        addObject(botPipe, getWidth(), getHeight()/2+image.getHeight()-Greenfoot.getRandomNumber(200));
        addObject(topPipe, getWidth(), botPipe.getY()-image.getHeight()-PIPE_SPACING);
    }

    /**
     * Prepare the world for the start of the program.
     * That is: create the initial objects and add them to the world.
     */
    private void prepare()
    {
        sun sun = new sun();
        addObject(sun,105,62);
        UFO uFO = new UFO();
        addObject(uFO,558,42);
        uFO.setLocation(96,265);
        uFO.setLocation(116,271);
    }
}
